// calculate Temperature for NTCLE413 Temperature Sensors
//https://arduinodiy.wordpress.com/2015/11/10/measuring-temperature-with-ntc-the-steinhart-hart-formula/

#include "NTCLE_Abstraction.h"

#define R0      10000.0     //Ohm
#define BETA    3435.0      //Kelvin
#define T0      298.15      //Kelvin

float calcTemp(int16_t adcVoltage, int16_t vref2){
    float tmp = ((float)vref2)/adcVoltage;
    float r_ntc = R0/(tmp-1.0);

    float temp = r_ntc / R0;        // (R/Ro)
    temp = logf(temp);              // ln(R/Ro)
    temp /= BETA;                   // 1/B * ln(R/Ro)
    temp += 1.0 / T0;               // + (1/To)
    temp = 1.0 / temp;              // Invert
    temp -= 273.15;                 // convert to °C
    
    return (int16_t)(temp+0.5);
}